#include "game.h"

#include <xolatile/chads.c>

void game_configure (void) {
	chad_define_trait ("Strength",  1, 1, 10);
	chad_define_trait ("Dexterity", 1, 1, 10);
	chad_define_trait ("Wisdom",    1, 1, 10);

	chad_define_skill ("Swords",       1, 1, 100);
	chad_define_skill ("Axes",         1, 1, 100);
	chad_define_skill ("Maces",        1, 1, 100);
	chad_define_skill ("Staves",       1, 1, 100);
	chad_define_skill ("Bows",         1, 1, 100);
	chad_define_skill ("Crossbows",    1, 1, 100);
	chad_define_skill ("Slings",       1, 1, 100);
	chad_define_skill ("Shields",      1, 1, 100);
	chad_define_skill ("Armour",       1, 1, 100);
	chad_define_skill ("Alchemy",      1, 1, 100);
	chad_define_skill ("Medicine",     1, 1, 100);
	chad_define_skill ("Mercantile",   1, 1, 100);
	chad_define_skill ("Farmer",       1, 1, 100);
	chad_define_skill ("Miner",        1, 1, 100);
	chad_define_skill ("Lumber",       1, 1, 100);
	chad_define_skill ("Traps",        1, 1, 100);
	chad_define_skill ("Water Magic",  1, 1, 100);
	chad_define_skill ("Earth Magic",  1, 1, 100);
	chad_define_skill ("Wind Magic",   1, 1, 100);
	chad_define_skill ("Black Magic",  1, 1, 100);
	chad_define_skill ("Rune Magic",   1, 1, 100);
	chad_define_skill ("Summon Magic", 1, 1, 100);
	chad_define_skill ("Ritual Magic", 1, 1, 100);
	chad_define_skill ("Charm Magic",  1, 1, 100);

	chad_define_value ("Coin",    1);
	chad_define_value ("Food",    2);
	chad_define_value ("Wood",    5);
	chad_define_value ("Stone",   7);
	chad_define_value ("Iron",   19);
	chad_define_value ("Silver", 23);
	chad_define_value ("Gold",   29);
	chad_define_value ("Coal",   13);
	chad_define_value ("Gems",   31);
	chad_define_value ("Mana",   37);

	chad_define_effect (CHAD_ENTITY_TRAIT, CHAD_TARGET_SELF | CHAD_TARGET_INCREASE, strength, 1);
	chad_define_effect (CHAD_ENTITY_TRAIT, CHAD_TARGET_SELF | CHAD_TARGET_INCREASE, strength, 3);
	chad_define_effect (CHAD_ENTITY_TRAIT, CHAD_TARGET_SELF | CHAD_TARGET_INCREASE, strength, 7);

	chad_define_might ("Might", gain_minor_strength);

	chad_define_magic ("Magic", 3, gain_major_strength);

	chad_define_race ("Orc",   strength,  axes,       wood);
	chad_define_race ("Human", dexterity, medicine,   iron);
	chad_define_race ("Elf",   wisdom,    rune_magic, gems);

	chad_define_item ("Iron Mace",  2, CHAD_ITEM_WEAPON, gain_minor_strength);
	chad_define_item ("Iron Sword", 3, CHAD_ITEM_WEAPON, gain_minor_strength);
	chad_define_item ("Iron Axe",   2, CHAD_ITEM_WEAPON, gain_minor_strength);

	chad_define_unit ("Gnoll",         "Dirt-Hut",           orc,   CHAD_UNIT_RANGE,                    1,  2, 7, -1);
	chad_define_unit ("Gnoll Shaman",  "Treehouse",          orc,   CHAD_UNIT_MAGIC,                    1,  3, 7, -1);
	chad_define_unit ("Goblin",        "Dirty Shed",         orc,   CHAD_UNIT_MELEE,                    2,  3, 7, -1);
	chad_define_unit ("Hob-Goblin",    "Old Barracks",       orc,   CHAD_UNIT_MELEE | CHAD_UNIT_MAGIC,  3,  5, 7, -1);
	chad_define_unit ("Thief",         "Thief Storehouse",   orc,   CHAD_UNIT_MELEE,                    3,  7, 5, -1);
	chad_define_unit ("Looter",        "Abandoned Manor",    orc,   CHAD_UNIT_RANGE,                    5,  7, 5, -1);
	chad_define_unit ("Warrior",       "Longhouse",          orc,   CHAD_UNIT_MELEE,                    7, 11, 5, -1);
	chad_define_unit ("Shaman",        "Cottage",            orc,   CHAD_UNIT_MAGIC,                    7, 11, 3, -1);
	chad_define_unit ("Chief",         "Campgrounds",        orc,   CHAD_UNIT_MELEE | CHAD_UNIT_RANGE, 11, 13, 3, -1);
	chad_define_unit ("Wolf-Rider",    "Wold Den",           orc,   CHAD_UNIT_MELEE | CHAD_UNIT_RANGE, 17, 17, 2, -1);
	chad_define_unit ("Boar-Rider",    "Boar Ranch",         orc,   CHAD_UNIT_RANGE,                   19, 23, 2, -1);
	chad_define_unit ("Overlord",      "Orcish Temple",      orc,   CHAD_UNIT_MELEE | CHAD_UNIT_MAGIC, 23, 13, 2, -1);
	chad_define_unit ("Ogre",          "Highlands",          orc,   CHAD_UNIT_MELEE,                   29, 23, 2, -1);
	chad_define_unit ("Ogre Mage",     "Highland Tower",     orc,   CHAD_UNIT_MELEE | CHAD_UNIT_MAGIC, 31, 29, 2, -1);
	chad_define_unit ("Troll",         "Troll Den",          orc,   CHAD_UNIT_MELEE,                   37, 31, 1, -1);
	chad_define_unit ("War Troll",     "Cavern-Fort",        orc,   CHAD_UNIT_MELEE | CHAD_UNIT_RANGE, 41, 37, 1, -1);
	chad_define_unit ("Basilisk",      "Dungeon",            orc,   CHAD_UNIT_MELEE | CHAD_UNIT_EXTRA, 53, 59, 1, -1);
	chad_define_unit ("Wyvern",        "Swamp Pit",          orc,   CHAD_UNIT_MELEE | CHAD_UNIT_EXTRA, 59, 53, 1, -1);
	chad_define_unit ("Peasant",       "Farm",               human, CHAD_UNIT_MELEE,                    1,  1, 7, -1);
	chad_define_unit ("Scout",         "Scout Shack",        human, CHAD_UNIT_RANGE,                    2,  3, 7, -1);
	chad_define_unit ("Hunter",        "Archery",            human, CHAD_UNIT_RANGE,                    2,  3, 7, -1);
	chad_define_unit ("Swordman",      "House of Slashing",  human, CHAD_UNIT_MELEE,                    3,  5, 7, -1);
	chad_define_unit ("Axeman",        "House of Cutting",   human, CHAD_UNIT_MELEE,                    5,  5, 5, -1);
	chad_define_unit ("Crossbowman",   "House of Shooting",  human, CHAD_UNIT_RANGE,                    5,  5, 5, -1);
	chad_define_unit ("Horseman",      "Horse Ranch",        human, CHAD_UNIT_MELEE,                    7, 11, 5, -1);
	chad_define_unit ("Guard",         "Guard Barracks",     human, CHAD_UNIT_MELEE,                    7,  7, 3, -1);
	chad_define_unit ("Elite Guard",   "Guard Home",         human, CHAD_UNIT_MELEE,                   13, 11, 3, -1);
	chad_define_unit ("Lancer",        "Riding Meadow",      human, CHAD_UNIT_MELEE | CHAD_UNIT_RANGE, 17, 17, 2, -1);
	chad_define_unit ("Knight",        "Mansion of Honour",  human, CHAD_UNIT_MELEE,                   19, 23, 2, -1);
	chad_define_unit ("Kingsman",      "King's Academy",     human, CHAD_UNIT_MELEE,                   19, 17, 2, -1);
	chad_define_unit ("Mage",          "School of Mana",     human, CHAD_UNIT_MAGIC,                   23,  7, 2, -1);
	chad_define_unit ("Arch-Mage",     "Temple of Mana",     human, CHAD_UNIT_MAGIC,                   29, 11, 2, -1);
	chad_define_unit ("Giant",         "Mound",              human, CHAD_UNIT_MELEE,                   41, 59, 1, -1);
	chad_define_unit ("War Giant",     "Mound-Fort",         human, CHAD_UNIT_MELEE | CHAD_UNIT_RANGE, 43, 67, 1, -1);
	chad_define_unit ("Griffin",       "Griffin Nest",       human, CHAD_UNIT_MELEE,                   47, 53, 1, -1);
	chad_define_unit ("Roc",           "Heavenly Temple",    human, CHAD_UNIT_MELEE | CHAD_UNIT_MAGIC, 53, 61, 1, -1);
	chad_define_unit ("Sprite",        "Little Lamp",        elf,   CHAD_UNIT_MELEE,                    1,  1, 7, -1);
	chad_define_unit ("Nature Spirit", "Flower Palace",      elf,   CHAD_UNIT_MELEE,                    1,  1, 7, -1);
	chad_define_unit ("Half-Elf",      "Slums",              elf,   CHAD_UNIT_MELEE,                    1,  3, 7, -1);
	chad_define_unit ("Ranger",        "Ranger Guild",       elf,   CHAD_UNIT_MELEE,                    3,  5, 7, -1);
	chad_define_unit ("Archer",        "Arrow House",        elf,   CHAD_UNIT_MELEE | CHAD_UNIT_RANGE,  3,  7, 5, -1);
	chad_define_unit ("Elite Archer",  "Arrow Fortress",     elf,   CHAD_UNIT_MELEE | CHAD_UNIT_RANGE,  5,  7, 5, -1);
	chad_define_unit ("Blademaster",   "School of Blades",   elf,   CHAD_UNIT_MELEE | CHAD_UNIT_MAGIC,  7, 11, 5, -1);
	chad_define_unit ("Water Mage",    "Water Temple",       elf,   CHAD_UNIT_MAGIC,                   11, 11, 3, -1);
	chad_define_unit ("Earth Mage",    "Earth Temple",       elf,   CHAD_UNIT_MAGIC,                   13, 13, 3, -1);
	chad_define_unit ("Wind Mage",     "Wind Temple",        elf,   CHAD_UNIT_MAGIC,                   13, 17, 2, -1);
	chad_define_unit ("Rune Mage",     "Rune Monastery",     elf,   CHAD_UNIT_MAGIC,                   17, 19, 2, -1);
	chad_define_unit ("Runemaster",    "Ancient Ruins",      elf,   CHAD_UNIT_MAGIC,                   19, 23, 2, -1);
	chad_define_unit ("Sacrificer",    "Altair",             elf,   CHAD_UNIT_MAGIC,                   23, 19, 2, -1);
	chad_define_unit ("Elk Rider",     "Elk Ranch-House",    elf,   CHAD_UNIT_MELEE,                   29, 23, 2, -1);
	chad_define_unit ("Warmaster",     "Elven Fort",         elf,   CHAD_UNIT_MELEE | CHAD_UNIT_MAGIC, 41, 59, 1, -1);
	chad_define_unit ("Coal Golem",    "Old Coal Mine",      elf,   CHAD_UNIT_MELEE,                   43, 53, 1, -1);
	chad_define_unit ("Iron Golem",    "Old Iron Mine",      elf,   CHAD_UNIT_MELEE,                   47, 67, 1, -1);
	chad_define_unit ("Sage",          "Cabin in the Woods", elf,   CHAD_UNIT_RANGE | CHAD_UNIT_MAGIC, 67, 47, 1, -1);

	chad_define_block ("Ashland", 0, 12, -1, -1, -1);
	chad_define_block ("Ashdirt", 0,  6, -1, -1, -1);
	chad_define_block ("Ashdust", 0,  6, -1, -1, -1);

	chad_define_block ("Garbage", CHAD_BLOCK_RANDOM, 12, -1, -1, -1);

	chad_define_block ("Ashdirt", CHAD_BLOCK_UP,    1, 0, 1, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_DOWN,  1, 0, 1, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_LEFT,  1, 0, 1, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_RIGHT, 1, 0, 1, -1);

	chad_define_block ("Ashdirt", CHAD_BLOCK_UP   | CHAD_BLOCK_LEFT,  1, 0, 1, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_UP   | CHAD_BLOCK_RIGHT, 1, 0, 1, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_DOWN | CHAD_BLOCK_LEFT,  1, 0, 1, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_DOWN | CHAD_BLOCK_RIGHT, 1, 0, 1, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_UP   | CHAD_BLOCK_LEFT,  1, 1, 0, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_UP   | CHAD_BLOCK_RIGHT, 1, 1, 0, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_DOWN | CHAD_BLOCK_LEFT,  1, 1, 0, -1);
	chad_define_block ("Ashdirt", CHAD_BLOCK_DOWN | CHAD_BLOCK_RIGHT, 1, 1, 0, -1);

	chad_define_block ("Ashdust", CHAD_BLOCK_UP,    1, 0, 2, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_DOWN,  1, 0, 2, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_LEFT,  1, 0, 2, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_RIGHT, 1, 0, 2, -1);

	chad_define_block ("Ashdust", CHAD_BLOCK_UP   | CHAD_BLOCK_LEFT,  1, 0, 2, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_UP   | CHAD_BLOCK_RIGHT, 1, 0, 2, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_DOWN | CHAD_BLOCK_LEFT,  1, 0, 2, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_DOWN | CHAD_BLOCK_RIGHT, 1, 0, 2, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_UP   | CHAD_BLOCK_LEFT,  1, 2, 0, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_UP   | CHAD_BLOCK_RIGHT, 1, 2, 0, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_DOWN | CHAD_BLOCK_LEFT,  1, 2, 0, -1);
	chad_define_block ("Ashdust", CHAD_BLOCK_DOWN | CHAD_BLOCK_RIGHT, 1, 2, 0, -1);

	chad_define_model ("Redgrass",        0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Bone",            0, 1, 1, -1);
	chad_define_model ("Redgrass",        0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock & Redgrass", 0, 1, 1, -1);
	chad_define_model ("Bones",           0, 1, 1, -1);
	chad_define_model ("Redgrass",        0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Redgrass",        0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Redgrass",        0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Redgrass",        0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Skull",           0, 1, 1, -1);
	chad_define_model ("Skull & Bones",   0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Gravestone",      0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Gravestone",      0, 1, 1, -1);
	chad_define_model ("Rock",            0, 1, 1, -1);
	chad_define_model ("Gravestone",      0, 1, 1, -1);
	chad_define_model ("Firewood",        0, 1, 1, -1);
	chad_define_model ("Firewood",        0, 1, 1, -1);
	chad_define_model ("Firewood",        0, 1, 1, -1);
	chad_define_model ("Acid Reed",       0, 1, 1, -1);
	chad_define_model ("Acid Reed",       0, 1, 1, -1);
	chad_define_model ("Acid Reed",       0, 1, 1, -1);
	chad_define_model ("Acid Reed",       0, 1, 1, -1);
	chad_define_model ("Acid Reed",       0, 1, 1, -1);
	chad_define_model ("Acid Reed",       0, 1, 1, -1);
	chad_define_model ("Sign",            0, 1, 1, -1);
	chad_define_model ("Sign",            0, 1, 1, -1);
	chad_define_model ("Sign",            0, 1, 1, -1);
	chad_define_model ("Sign",            0, 1, 1, -1);

	chad_define_model ("Huge Rock",         CHAD_MODEL_CLIP, 1, 2, -1);
	chad_define_model ("Huge Acid Reed",    CHAD_MODEL_CLIP, 1, 2, -1);
	chad_define_model ("Tree Trunk",        CHAD_MODEL_CLIP, 1, 2, -1);
	chad_define_model ("Tree Trunk",        CHAD_MODEL_CLIP, 1, 2, -1);
	chad_define_model ("Tree Trunk",        CHAD_MODEL_CLIP, 1, 2, -1);
	chad_define_model ("Tree Trunk",        CHAD_MODEL_CLIP, 1, 2, -1);
	chad_define_model ("Huge Rock & Skull", CHAD_MODEL_CLIP, 1, 2, -1);
	chad_define_model ("Huge Acid Reed",    CHAD_MODEL_CLIP, 1, 2, -1);

	chad_define_model ("Tree Trunk",           CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Tree Trunk",           CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Huge Acid Reed",       CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Huge Acid Reed",       CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Huge Rock",            CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Huge Rock",            CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Huge Sign",            CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Firewood & Bone",      CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Huge Rock & Redgrass", CHAD_MODEL_CLIP, 2, 1, -1);
	chad_define_model ("Huge Rock & Skull",    CHAD_MODEL_CLIP, 2, 1, -1);

	chad_define_model ("Huge Rocks",            CHAD_MODEL_CLIP, 2, 2, -1);
	chad_define_model ("Gravestone & Redgrass", CHAD_MODEL_CLIP, 2, 2, -1);
	chad_define_model ("Firewood & Redgrass",   CHAD_MODEL_CLIP, 2, 2, -1);

	chad_define_model ("Dead Tree", CHAD_MODEL_CLIP, 2, 4, -1);
	chad_define_model ("Dead Tree", CHAD_MODEL_CLIP, 2, 4, -1);

	chad_define_model ("Huge Rocks", CHAD_MODEL_CLIP, 3, 2, -1);

	chad_define_model ("Dead Tree",             CHAD_MODEL_CLIP, 4, 5, -1);
	chad_define_model ("Dead Tree & Skulls",    CHAD_MODEL_CLIP, 4, 5, -1);
	chad_define_model ("Dead Tree & Acid Reed", CHAD_MODEL_CLIP, 4, 5, -1);

	chad_define_world ("Ashlands", 0XBEEF, 0, chad_block_count);

	chad_configure ();
}
